'graphit
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  _stack = ($3000 + $3000 + 100) >> 2   'accomodate display memory and stack

  x_tiles = 16
  y_tiles = 12

  paramcount = 14       
  bitmap_base = $2000
  display_base = $5000

  lines = 5
  thickness = 2
  reps = 4
  

VAR

  long  tv_status     '0/1/2 = off/visible/invisible           read-only
  long  tv_enable     '0/? = off/on                            write-only
  long  tv_pins       '%ppmmm = pins                           write-only
  long  tv_mode       '%ccinp = chroma,interlace,ntsc/pal,swap write-only
  long  tv_screen     'pointer to screen (words)               write-only
  long  tv_colors     'pointer to colors (longs)               write-only               
  long  tv_hc         'horizontal cells                        write-only
  long  tv_vc         'vertical cells                          write-only
  long  tv_hx         'horizontal cell expansion               write-only
  long  tv_vx         'vertical cell expansion                 write-only
  long  tv_ho         'horizontal offset                       write-only
  long  tv_vo         'vertical offset                         write-only
  long  tv_broadcast  'broadcast frequency (Hz)                write-only
  long  tv_auralcog   'aural fm cog                            write-only

  word  screen[x_tiles * y_tiles]
  long  colors[64]
  long samples[100]
OBJ

  tv    : "tv"
  gr    : "graphics"


PUB start | i, j, kk, dx, dy, pp, pq, rr, numx, numchr,dechr,xG,yG,digit1,digit2,digit3,digit4,sample,px,py

  'start tv
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  
  'init colors
  repeat i from 0 to 63
    colors[i] := $00001010 * (i+4) & $F + $2B060C02

  'init tile screen
  repeat dx from 0 to tv_hc - 1
    repeat dy from 0 to tv_vc - 1
      screen[dy * tv_hc + dx] := display_base >> 6 + dy + dx * tv_vc + ((dy & $3F) << 10)

  'start and setup graphics
  gr.start
  gr.setup(16, 12, 128, 96, bitmap_base)
  'start mouse
  samples:=0
  plot(0)
  return (1)
pub plot(value)  |i, j, kk, dx, dy, pp, pq, rr, numx, numchr,dechr,xG,yG,digit1,digit2,digit3,digit4,sample,px,py 
  'repeat

    gr.clear
    sample:=sample + 1

    if sample > 99
      longfill(@samples,0,100)
      sample:=1
    samples[sample]:=value

    gr.colorwidth(2,0)
    repeat i from 0 to 99
      px:=-115 + 2*i
      py:= samples[i]/16
      gr.plot(px,0)

      gr.line(px,py)

        'draw axis
    gr.colorwidth(2,0)
    gr.color(2)
    gr.plot(-115,-0)
    gr.line(-115,60)

    gr.textmode(1,1,7,5)
    dechr:="0"
    
    gr.text(-126,0,@dechr)
    dechr:="9"
    gr.text(-126,65,@dechr)
    dechr:="0"
    gr.text(-120,65,@dechr)
    dechr:="6"
    gr.text(-126,40,@dechr)
    dechr:="5"
    gr.text(-120,40,@dechr)

    gr.plot(-115,0)

    'draw small boxwith text
    gr.colorwidth(1,14)
    gr.box(60,64,60,16)
    gr.textmode(1,1,6,5)
    gr.colorwidth(2,0)
    gr.text(90,72,@pchip)

    gr.textmode(2,2,6,5)
    GR.TEXT(-60,-20,@MPH )

    'draw incrementing digit

    digit1:=||value/1000
    digit2:=(||value//1000)/100
    digit3:=((||value//1000)//100)/10
    digit4:=((||value//1000)//100)//10 

    gr.textmode(3,3,6,5)
    gr.colorwidth(2,0)
    numchr:=numarray[digit1]
    'gr.text(-30,-20,@numchr)
    dechr:="."
    'gr.text(-15,-20,@dechr)
    
    numchr:=numarray[digit2]
    gr.text(0,-20,@numchr)
    numchr:=numarray[digit3]
    gr.text(20,-20,@numchr)
    numchr:=numarray[digit4]
   ' gr.text(40,-20,@numchr)
    dechr:="+"
    if samples[sample] < 0
      dechr:= "-"
    gr.text(-20,-20,@dechr)
    'copy bitmap to display
    gr.copy(display_base)

    

 

 
DAT

tvparams                long    0               'status
                        long    1               'enable
                        long    %001_0101       'pins
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    x_tiles         'hc
                        long    y_tiles         'vc
                        long    10              'hx
                        long    1               'vx
                        long    0               'ho
                        long    0               'vo
                        long    0               'broadcast
                        long    0               'auralcog

vecdef                  word    $4000+$2000/3*0         'triangle
                        word    50
                        word    $8000+$2000/3*1+1
                        word    50
                        word    $8000+$2000/3*2-1
                        word    50
                        word    $8000+$2000/3*0
                        word    50
                        word    0

vecdef2                 word    $4000+$2000/12*0        'star
                        word    50
                        word    $8000+$2000/12*1
                        word    20
                        word    $8000+$2000/12*2
                        word    50
                        word    $8000+$2000/12*3
                        word    20
                        word    $8000+$2000/12*4
                        word    50
                        word    $8000+$2000/12*5
                        word    20
                        word    $8000+$2000/12*6
                        word    50
                        word    $8000+$2000/12*7
                        word    20
                        word    $8000+$2000/12*8
                        word    50
                        word    $8000+$2000/12*9
                        word    20
                        word    $8000+$2000/12*10
                        word    50
                        word    $8000+$2000/12*11
                        word    20
                        word    $8000+$2000/12*0
                        word    50
                        word    0

pixdef                  word                            'crosshair
                        byte    2,7,3,3
                        word    %%00333000,%%00000000
                        word    %%03020300,%%00000000
                        word    %%30020030,%%00000000
                        word    %%32222230,%%00000000
                        word    %%30020030,%%02000000
                        word    %%03020300,%%22200000
                        word    %%00333000,%%02000000

pixdef2                 word                            'dog
                        byte    1,4,0,3
                        word    %%20000022
                        word    %%02222222
                        word    %%02222200
                        word    %%02000200

pchip                   byte    "Propeller",0           'text
numarray                byte    "0123456789",0
MPH                     BYTE    "MPH",0
minus1                  byte    "-1",0